
#include "kolibri.h"
#include "stdlib.h"
#include "string.h"

#include "my_gblib.h"
#include "my_psf_font.h"


/// ===========================================================

void putstring(GB_BMP *dest, int x, int y, GB_BMP *font, int w, int h, char *str)
{

int i;
for (i = 0; ;i++)
	if (*(str+i) == '\0')
		break;
	else
		gb_image_set(dest, x+i*w, y, font, 0, h*((unsigned char)*(str+i)), w, h);

}

/// ===========================================================

void kol_main()
{

GB_BMP			b;
GB_BMP			b_font;
kol_struct_import	*imp_gblib;
kol_struct_import	*imp_psf;
unsigned		event;
char font_path[] = "/sys/fonts/cp866-8x16.psf";
psf1_header p1;

imp_gblib = kol_cofflib_load("/sys/lib/gblib.obj"); 

gb_image_set = kol_cofflib_procload (imp_gblib, "gb_image_set");
gb_bar = kol_cofflib_procload (imp_gblib, "gb_bar");


imp_psf = kol_cofflib_load("/sys/lib/psf_font.obj"); 
psf_info = kol_cofflib_procload (imp_psf, "psf_info");
psf_load = kol_cofflib_procload (imp_psf, "psf_load");

b.w = 300; 
b.h = 200;
b.bmp = malloc (300*200*3);

psf_info(font_path, &p1);
b_font.w = 8;
b_font.h = p1.charsize*256;
b_font.bmp = malloc(b_font.w * b_font.h * 3 * 8);

psf_load(font_path, b_font.bmp);

gb_bar(&b, 0, 0, 300, 200, 0xffffff);

putstring (&b, 0, 0, &b_font, b_font.w, b_font.h/256, " cp866-8x16.psf");

for (;;)
	{
	event = kol_event_wait();

	switch (event)
		{
		case 1:
			kol_paint_start();
			kol_wnd_define(50, 50, 350, 240, 0x34ffffff);
			kol_paint_image(3, 3, 300, 200, b.bmp);
			kol_paint_end();
			break;

		case 2:
			kol_key_get();
			break;

		case 3:
			if ( 1 == (kol_btn_get() & 0xff00)>>8 )
				kol_exit();
			break;

		};


	}

}

/// ===========================================================
