
#define PSF1_MAGIC0     0x36
#define PSF1_MAGIC1     0x04

#define PSF1_MODE512    0x01
#define PSF1_MODEHASTAB 0x02
#define PSF1_MODEHASSEQ 0x04
#define PSF1_MAXMODE    0x05

#define PSF1_SEPARATOR  0xFFFF
#define PSF1_STARTSEQ   0xFFFE


typedef struct {
        unsigned char magic[2] __attribute__((packed));     /* Magic number */
        unsigned char mode     __attribute__((packed));     /* PSF font mode */
        unsigned char charsize __attribute__((packed));     /* Character size */
} psf1_header;


void (* __stdcall psf_info)(char *filename, psf1_header *psf1_h);
void (* __stdcall psf_load)(char *filename, char *bmp);
