
#include "psf_font.h"

//=========================

typedef struct 
{
unsigned	p00 __attribute__((packed));
unsigned	p04 __attribute__((packed));
unsigned	p08 __attribute__((packed));
unsigned	p12 __attribute__((packed));
unsigned	p16 __attribute__((packed));
char		p20 __attribute__((packed));
char		*p21 __attribute__((packed));
} kol_struct70 __attribute__((packed));

//=========================

int kol_file_70(kol_struct70 *k)
{
asm ("int $0x40"::"a"(70), "b"(k));
}

//=========================

void* malloc(unsigned s)
{
asm ("int $0x40"::"a"(68), "b"(12), "c"(s) );
}

//=========================

void free(void *p)
{
asm ("int $0x40"::"a"(68), "b"(13), "c"(p) );
}

//=========================

void psf_info(char *filename, psf1_header *psf1_h)
{
kol_struct70	k70;

psf1_h -> charsize = 0;
psf1_h -> mode = 0;
psf1_h -> magic[0] = 0;
psf1_h -> magic[1] = 0;

k70.p00 = 0;
k70.p04 = 0;
k70.p08 = 0;
k70.p12 = sizeof(psf1_header);
k70.p16 = psf1_h;
k70.p20 = 0;
k70.p21 = filename;

kol_file_70(&k70);
}

//=========================

int psf_load(char *filename, char *bmp)
{

kol_struct70	k70;
psf1_header psf1_h;
char *buf1;
int len1;
int i, j;
char temp;

k70.p00 = 0;
k70.p04 = 0;
k70.p08 = 0;
k70.p12 = sizeof(psf1_header);
k70.p16 = &psf1_h;
k70.p20 = 0;
k70.p21 = filename;

kol_file_70(&k70);

if ((psf1_h.magic[0] != PSF1_MAGIC0)||(psf1_h.magic[1] != PSF1_MAGIC1))
	return 0;

len1 = psf1_h.charsize*8*32;
buf1 = (char*) malloc(len1);

k70.p00 = 0;
k70.p04 = sizeof(psf1_header);
k70.p08 = 0;
k70.p12 = len1;
k70.p16 = buf1;
k70.p20 = 0;
k70.p21 = filename;

kol_file_70(&k70);

for (i = 0; i < psf1_h.charsize*256; i++)
	{
	temp = *(buf1+i);
	for (j = 0; j < 8; j++)
		{
		*(bmp+i*8*3+3*j+0) = (((temp>>(7-j))&1)^1)*0xff;
		*(bmp+i*8*3+3*j+1) = (((temp>>(7-j))&1)^1)*0xff;
		*(bmp+i*8*3+3*j+2) = (((temp>>(7-j))&1)^1)*0xff;
		}
	}

free(buf1);

return 1;
}

//=========================

#define NULL ((void*)0)

typedef struct
{
void	*name;
void	*function;
} export_t;

//=========================

char szPsf_info[] = "psf_info";
char szPsf_load[] = "psf_load";

export_t EXPORTS[] =
{
{szPsf_info, (void*) psf_info}, 
{szPsf_load, (void*) psf_load}, 
{ NULL, NULL }
};

//=========================
